<template>
  <div class="h-100">
    <RegistrationInstructionAlert v-if="currentHostname === 'gruzi'" />
    <left-form-wrapper
      title="Вход"
      :handle-back="handleBack"
      background="2"
      :show-info-message="showInfoMessage"
    >
      <ObForm
        :form-data="formData"
        :form-model="formModel"
        ok-text="Войти"
        :is-show-controls="true"
        :is-only-submit="true"
        style="paddingTop: 20vh"
        :is-on-press-enter-submit="true"
        :is-loading="isLoading"
        @submit="sendFormData"
      >
        <ObAlert
          v-if="isQueryMail"
          text="Почта подтверждена, войдите с паролем из письма"
          icon="checked"
          theme="success"
          :hideCloseButton="true"
        />

        <div class="mb20">
          <ObInput
            v-model="formData.username"
            label="Электронная почта"
            placeholder="Адрес электронной почты"
            property="username"
          />
        </div>
        <div>
          <ObInput
            v-model="formData.password"
            label="Пароль"
            :placeholder="`Введите пароль${isQueryMail ? ' из письма' : ''}`"
            :is-valid="error === null ? null : !error"
            type="password"
            property="password"
          />
        </div>
        <transition name="fadeIn">
          <ObAlert
            v-if="error"
            :text="error"
            :hide-close-button="true"
            class="alert-error"
            theme="danger"
            icon="alert"
          />
        </transition>

        <template slot="footer" v-if="!isQueryMail">
          <div class="footer-content">
            <router-link tag="a" :to="{ name: 'restore' }" class="footer__link">
              Не помню пароль
            </router-link>
          </div>
        </template>
      </ObForm>
      <div slot="footer" v-if="!isQueryMail">
        Нет аккаунта?
        <router-link :to="{ name: 'registration' }">
          Зарегистрироваться
        </router-link>
      </div>
    </left-form-wrapper>
  </div>
</template>
<script>
import { mapMutations, mapActions } from "vuex";
import ObForm from "common-components/src/obComponents/obForm";
import ObInput from "common-components/src/obComponents/obInput";
import ObAlert from "common-components/src/obComponents/obAlert";
import { required, email } from "vuelidate/lib/validators";
import FormValidationMixin from "common-components/src/obComponents/obForm/FormValidationMixin";
import api from "@/api";
import VueCookie from "vue-cookie";
import LeftFormWrapper from "../../components/LeftFormWrapper";
import routeMixin from "../../mixins/route-mixin";
import { getTokenData } from "@/tokenData";
import RegistrationInstructionAlert from "../../components/RegistrationInstructionAlert";

export default {
  name: "LoginPage",
  components: {
    ObForm,
    ObInput,
    ObAlert,
    LeftFormWrapper,
    RegistrationInstructionAlert,
  },
  mixins: [FormValidationMixin, routeMixin],
  data() {
    return {
      error: null,
      loginTimeout: null,
      isLoading: false,
      isLoginEnabled: true,
      showInfoMessage: true,
    };
  },
  created() {
    if (VueCookie.get("auth_token")) {
      this.checkStatus(
        VueCookie.get("auth_token"),
        VueCookie.get("refresh_token")
      );
    }
    sessionStorage.numOpenConnections = 0;
  },
  computed: {
    isQueryMail: ({ $route }) => $route.query?.email,

    formModel() {
      return {
        username: {
          value: "",
          validator: {
            required,
            email: {
              method: email,
              error: "Некорректный email",
            },
          },
        },
        password: {
          value: "",
          validator: {
            required,
            checkLoginAvailability: () => this.isLoginEnabled,
          },
        },
      };
    },
    currentHostname() {
      return window.location.host.split("gruzi").length > 1 ? "gruzi" : "oboz";
    },
  },
  watch: {
    formData: {
      deep: true,
      handler() {
        if (this.error) {
          this.error = null;
        }
      },
    },
    "formData.username"() {
      if (!this.isLoginEnabled) {
        this.isLoginEnabled = true;

        clearTimeout(this.loginTimeout);
      }
    },
  },
  mounted() {
    if (this.isQueryMail) this.formData.username = this.$route.query.email;

    if (this.currentHostname === "gruzi") this.showInfoMessage = false;
  },
  methods: {
    ...mapActions({
      fetchMenu: "functions/fetchMenu",
      setFinishedRegistrationStatus: "entry/setFinishedRegistrationStatus",
    }),
    ...mapMutations({
      setTokenData: "user/setTokenData",
    }),

    async sendFormData() {
      this.error = null;
      this.isLoading = true;

      try {
        let data = await api.registration.auth.login(this.formData);
        let token = data.token;
        let refreshToken = data.refreshToken;
        this.checkStatus(token, refreshToken);
        this.isLoading = false;
        await this.fetchMenu();
      } catch (e) {
        this.showError(e);
        this.isLoading = false;
      }
    },
    showError(e) {
      switch (e?.status) {
        case 401:
          this.isLoginEnabled = false;

          this.loginTimeout = setTimeout(() => {
            this.isLoginEnabled = true;
          }, 5000);

          this.error =
            "Слишком много неудачных попыток входа. Попробуйте войти через 30 минут";
          break;

        default:
          this.error = "Неверный логин или пароль";
          break;
      }
    },
    async checkStatus(token, refreshToken) {
      if (!token) {
        this.showError();
      } else {
        VueCookie.set("auth_token", token);
        VueCookie.set("refresh_token", refreshToken);
        localStorage.setItem("refresh_auth_token", token);
        this.setTokenData();
        let userInfo = null;
        const response = await api.registration.auth.status();
        const status = response.participantStatus;
        const isNewUser = status === "NEW";
        const draftOrderIdString = "anon_order_draft_uuid";
        const draftOrderId = VueCookie.get(draftOrderIdString);

        this.$nextTick(async () => {
          const { contractor_role_code } = { ...getTokenData() };
          // Default route
          let route = { name: "settings__sb_settings__task_monitor" };

          if (draftOrderId) {
            if (isNewUser) {
              // Need to relocate before token refreshment
              await api.registration.auth.relocateAnonymous(draftOrderId);
              route = `order-drafts-item/${draftOrderId}`;
              await api.registration.accreditation.setUserActivitiesAndPersonalData({ draftOrderId });
              const data = await api.registration.auth.refresh({ token: refreshToken });
              VueCookie.set("auth_token", data.token);
              VueCookie.set("refresh_token", data.refreshToken);
              localStorage.setItem("refresh_auth_token", token);
              await this.fetchMenu();
            }

            VueCookie.delete(draftOrderIdString);
          }

          if (isNewUser && !draftOrderId) {
            // Continue on registration steps 3 and 4
            route.name = "registration";
          } else {
            userInfo = await api.registration.auth.getUserInfo();
            
            const isTenderRoles =
              userInfo?.roles?.length &&
              Boolean(
                userInfo.roles.find((item) =>
                  ["организатор тендера", "участник тендера"].includes(
                    item.name && item.name.toLowerCase()
                  )
                )
              );

            if (isTenderRoles) {
              route.name = "tenders__tenders";
            } else if (contractor_role_code === "clicar") {
              route.name = "order__performerer";
            } else if (contractor_role_code === "carrier") {
              route.name = "requests__search-orders";
            } else if (contractor_role_code === "client" && draftOrderId) {
              // Relocate already registered client
              await api.registration.auth.relocateAnonymous(draftOrderId);
              route = `order-drafts-item/${draftOrderId}`;
            }
          }

          this.$router.replace(route);
        });
      }
    },
  },
  metaInfo() {
    return {
      meta: [{ name: "yandex", content: "noindex, nofollow" }],
    };
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.alert-error {
  margin: 20px 0 40px;
}

.footer {
  &-content {
    display: block;
    width: 100%;
    text-align: center;
    margin-top: 25px;
  }

  &__pdfs {
    display: flex;
    flex-direction: column;
    text-align: center;
    margin-top: 50px;

    a {
      @include font-mixin(12px, 30px, 400, $color-blue-navy-blue);

      text-decoration: none;
    }
  }
}
</style>
